<template>
  <main>
    <v-container>
      <v-layout row>
        <v-flex sm12 class="text-sm-center" v-if="loading">
          <v-progress-circular indeterminate class="primary--text"></v-progress-circular>
        </v-flex>
        <v-flex sm12 v-else>
          <v-card>
            <v-card-title primary-title>
              <div>
                <div class="headline">{{user.full_name || 'Full name is required.'}}</div>
                <div class="grey--text">{{user.team || 'No team'}} | {{user.teamPosition || 'No position'}}</div>
              </div>
            </v-card-title>
            <v-form method="post" @submit.prevent="saveChanges" ref="profileForm">
              <v-card-text>
                <v-layout row>
                  <!-- Account Information -->
                  <v-flex sm7 class="pr-2">
                    <v-text-field label="Full Name" v-model="user['full_name']" :rules="[$rules.required]" required />
                    <v-text-field label="Email" v-model="user['email']" />
                    <v-text-field label="Contact" v-model="user['mobile']" :rules="[$rules.required]" required />
                    <v-divider class="mt-3"></v-divider>

                    <h3 class="grey--text subheading fw-300 mb-0">Address</h3>
                    <v-text-field label="Line 1" v-model="user.address['line1']" />
                    <v-text-field label="Line 2" v-model="user.address['line2']" />
                    <v-text-field label="Barangay" v-model="user.address['baranggay']" />
                    <v-text-field label="City" v-model="user.address['city']" />
                    <v-text-field label="SPR" v-model="user.address['spr']" />
                    <v-text-field label="Country" v-model="user.address['country']" />
                    <v-text-field label="ZIP" v-model="user.address['zip']" />
                    <v-divider class="mt-3"></v-divider>

                    <h3 class="grey--text subheading fw-300 mb-0">Other Information</h3>
                    <v-menu lazy v-model="dialog['menu']" :close-on-content-click="false" max-width="290" :nudge-right="40">
                      <v-text-field slot="activator" label="Birthdate" v-model="user['birthday']" hint="Click the 'year' to select a different one." persistent-hint readonly></v-text-field>
                      <v-date-picker v-model="user['birthday']" scrollable actions>
                        <template scope="{save}">
                          <v-card-actions>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-date-picker>
                    </v-menu>
                    <v-text-field label="School" v-model="user['school']" />
                    <v-text-field label="Work" v-model="user['work']" />
                    <v-text-field label="Hobbies" v-model="user['hobbies']" hint="Type in hobbies separated by commas." persistent-hint />
                    <v-text-field label="Interests" v-model="user['interests']" />
                  </v-flex>
                  <!-- Other Information -->
                  <v-flex sm5 class="pl-2">
                    <v-text-field label="Team" v-model="user['team']" />
                    <v-text-field label="Position" v-model="user['teamPosition']" />
                    <v-select label="Account Type" v-model="user['role']" :items="accountType"></v-select>
                    <v-select label="Assign Court" v-model="user['court']" :items="courts" v-if="user['role'] === 'merchant'"></v-select>
                  </v-flex>
                </v-layout>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions>
                <v-btn flat primary type="submit" :loading="saving" :disabled="saving">
                  Save Changes
                  <span slot="loader">Saving...</span>
                </v-btn>
                <v-dialog v-model="dialog.changesSaved" lazy>
                  <v-card>
                    <v-card-title class="pb-0">
                      <div class="headline">Done</div>
                    </v-card-title>
                    <v-card-text>
                      Changes to this profile has been saved.
                    </v-card-text>
                    <v-card-actions>
                      <v-spacer />
                      <v-btn class="primary--text" flat @click="dialog.changesSaved = false">Okay</v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
              </v-card-actions>
            </v-form>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  import AppShell from '@/components/app-shell'
  import moment from 'moment'
  export default {
    name: 'user',
    components: {AppShell},
    // watch: {
    //   hobbies (to, from) {
    //     let hobbies = to.split(',')
    //     if (hobbies.length > 0) hobbies.forEach((hobby, index) => (hobbies[index] = hobby.trim()))
    //     this.user.hobbies = (hobbies.length > 0) ? hobbies : [to]
    //   }
    // },
    data () {
      return {
        dialog: {
          changesSaved: false
        },
        loading: true,
        saving: false,
        db: this.$database.ref(`users/${this.$route.params.id}`),
        user: {
          // hobbies: [],
          address: {}
        },
        // hobbies: null,
        accountType: [
          {text: 'Player', value: 'player'},
          {text: 'Merchant', value: 'merchant'},
          {text: 'Admin', value: 'admin'}
        ],
        courts: []
      }
    },
    methods: {
      saveChanges () {
        this.saving = true
        if (this.$refs.profileForm.validate()) {
          if (this.user.birthday) {
            this.user.birthday = moment(this.user.birthday, 'YYYY-MM-DD').format('MM/DD/YYYY')
          }

          this.db.set(this.user).then(() => {
            this.dialog.changesSaved = true
            this.saving = false
            if (this.user.birthday) {
              this.user.birthday = moment(this.user.birthday, 'MM/DD/YYYY').format('YYYY-MM-DD')
            }
          })

          if (this.user.court) {
            this.$database.ref(`merchants/${this.user.court}/owner`).set(this.$route.params.id)
          }
        }
      }
    },
    created () {
      this.db.once('value').then(snapshot => {
        let user = snapshot.val()
        user.address = user.address || {}
        // this.hobbies = user.hobbies ? user.hobbies.join(', ') : ''
        this.loading = false
        this.user = user

        if (user.birthday) {
          this.user.birthday = moment(user.birthday, 'MM/DD/YYYY').format('YYYY-MM-DD')
        }

        if (user.level === 'merchant') {
          this.$database.ref('merchants').once('value').then(snapshot => {
            let courts = snapshot.val()
            Object.keys(courts).forEach(court => {
              this.courts.push({text: courts[court].courtName, value: court})
            })
          })
        }
      })
    }
  }
</script>

<style scoped>
  .menu {
    width: 100%;
  }
</style>
